<%@ page import="com.sas.oprisk.monitor.web.content.*" %>
<%@ page import="com.sas.oprisk.monitor.web.layout.*" %>
<%@ page import="com.sas.solutions.cpb.web.util.ViewMode" %>
<%@ page import="com.sas.fsd.shared.util.StringUtil" %>
<%@ page import="java.text.MessageFormat" %>
<%@ page import="java.util.ResourceBundle" %>
<%@ page import="com.sas.oprisk.server.ConfigDataProperties" %>
<%@ page import="com.sas.oprisk.server.ApplicationProperties" %>
<%@ taglib uri="http://www.sas.com/oprisk/monitor/tags" prefix="mon" %>
<%@ taglib uri="http://struts.apache.org/tags-html" prefix="html" %>
<%@ taglib uri="http://java.sun.com/jsp/jstl/fmt" prefix="fmt" %>
<%
   PageLayout pageLayout = PageLayout.getPageLayout(request);
   ContentDialogModel model = ContentDialogModel.getFromRequest(request);
   ResourceBundle bundle = ApplicationProperties.getBundle(request.getLocale());
   long maxLengthMB = (long)ConfigDataProperties.getMaxRestAttachmentSizeMB();
   String lengthMsg = MessageFormat.format(bundle.getString("contentManagement.content.illegalFileSize.fmt.txt"),
      new Object[] {maxLengthMB});
%>
<mon:Page template="innerpopup">
<%-- BEGIN PAGE --%>

   <mon:Head>
   <%-- BEGIN HEAD --%>
      <mon:include js="/components/contentmgmt/ContentDialog.js" />
      <mon:include js="/ext/cpbcore/util/FormUtil.js"/>
      <mon:include js="/ext/cpbcore/bgoverlay/BackgroundOverlay.js" />
      
      <mon:include properties='<%= new String[] {
         "contentManagement.content.confirm.saveMyChanges.txt"
         } %>' />

   <%-- END HEAD --%>
   </mon:Head>
   
   <mon:Body>
   <%-- BEGIN BODY --%>
      <script type="text/javascript">
      ContentDialog.COMPONENT_INSTANCE_ID = '<%= StringUtil.escapeJSForHTML(model.getComponentInstanceId()) %>';
      ContentDialog.davResourceOutOfSynch = <%= model.isDAVResourceOutOfSynch() %>;
<%
   /*
    * If we detected that the resource is out-of-synch and if the user is not
    * editing or cannot edit then refresh the content management component
    */
   if (model.getContentManagementComponentNeedsRefresh())
   {
%>
      ContentDialog.refreshContentManagementComponent();
<%
   }
%>
      </script>
   
      <form name="<%=ContentDialogModel.FORM_NAME%>"
         onsubmit="return ContentDialog.onSubmit(this, <%=maxLengthMB * 1024L * 1024L %>, '<%=lengthMsg %>')"
         method="post"
         action="<%=request.getContextPath()%>/ContentDialog"
         enctype="multipart/form-data">
      
      <mon:Content>
      <%-- BEGIN CONTENT --%>
      
         <mon:Hidden name="method" value="saveChanges" />
         <mon:Hidden name="<%= ContentManagementComponent.PARAM_INSTANCE_ID %>" value="<%=StringUtil.escapeJSForHTMLAttribute(model.getComponentInstanceId())%>" />
         <mon:Hidden name="<%= ContentManagementComponent.PARAM_UI_CONTEXT_ID %>" value="<%=model.getComponentUIContext().getUIContextId()%>" />
         <mon:Hidden name="<%= ContentManagementComponent.PARAM_SCREEN_ID %>" value="<%=model.getComponentScreen().getID()%>" />
         <mon:Hidden name="<%= ContentManagementComponent.PARAM_FIELD_INDEX %>" value="<%=new Integer(model.getComponentField().getFieldIndex())%>" />
         <mon:Hidden name="<%= ContentManagementComponent.PARAM_FILE_NAME %>" value="<%= model.getFileName() %>" />
         <mon:Hidden name="<%= ContentManagementComponent.PARAM_VERSION_NAME %>" value="<%= model.getVersionName() %>" />
         <mon:Hidden name="<%= ContentManagementComponent.PARAM_BUSINESS_OBJECT_REF %>" value="<%= model.getBusinessObjectRef() %>" />
         <mon:Hidden name="<%= ContentManagementComponent.PARAM_TYPE %>" value="<%= model.getType() %>" />
         <mon:Hidden name="<%= ContentManagementComponent.PARAM_READ_ONLY %>" value="<%= Boolean.valueOf(model.isReadOnly()) %>" />       
         <mon:Hidden name="<%= ContentManagementComponent.PARAM_GROUP_NUMBER %>" value="<%= model.getGroupNo() %>" />
<%
   model.getScreenRenderer().write(pageContext, out);
%>
      <%-- END CONTENT --%>
      </mon:Content>
      
      <mon:PopupButtonBar>
      <%-- BEGIN TOOL BAR --%>
<%
   if (model.getDAVResourceConcurrentlyModified())
   {
   %>
         <mon:Button onclick="ContentDialog.saveChanges(this)">
            <fmt:message key="application.ok.txt" />
         </mon:Button>
         
         <mon:Button onclick="ContentDialog.cancel()">
            <fmt:message key="application.cancel.txt" />
         </mon:Button>
<%
   }
   else if (model.getType() == ContentManagementComponentType.DELETED)
   {
%>
         <mon:Button type="submit">
            <fmt:message key="application.restore.txt" />
         </mon:Button>
         
         <mon:Button onclick="ContentDialog.cancel()">
            <fmt:message key="application.cancel.txt" />
         </mon:Button>
<%
   }
   else if (model.getScreenRenderer().isReadOnly())
   {
%>
         <mon:Button onclick="ContentDialog.cancel()">
            <fmt:message key="application.button.done.txt" />
         </mon:Button>
<%
   }
   else
   {
%>
         <mon:Button type="submit">
            <fmt:message key="application.ok.txt" />
         </mon:Button>
         
         <mon:Button onclick="ContentDialog.cancel()">
            <fmt:message key="application.cancel.txt" />
         </mon:Button>
<%
   }
%>
      <%-- END TOOL BAR --%>
      </mon:PopupButtonBar>
      
      </form>
      
   <%-- END BODY --%>
   </mon:Body>
   
<%-- END PAGE --%>
</mon:Page>