<%@ page import="com.sas.solutions.cpb.web.util.*" %>
<%@page import="com.sas.oprisk.framework.server.objects.BusinessObject.ClassObject"%>
<%@page import="org.apache.struts.config.ForwardConfig"%>
<%@page import="org.apache.struts.config.ModuleConfig"%>
<%@page import="org.apache.struts.taglib.TagUtils"%>
<%@page import="org.apache.struts.action.ActionForward"%>
<%@page import="com.sas.servlet.util.URLEncoder"%>
<%@ page import="com.sas.solutions.cpb.web.tag.field.ComponentFieldRenderer" %>
<%@ page import="com.sas.oprisk.server.cpb.MonitorUIDefinitionType" %>
<%@ page import="com.sas.oprisk.server.directive.*" %>
<%@ page import="com.sas.oprisk.monitor.web.user.actions.*" %>
<%@ page import="com.sas.oprisk.monitor.web.linking.*" %>
<%@ page import="java.util.*" %>
<%@ page import="com.sas.oprisk.server.logical.*" %>
<%@ page import="com.sas.oprisk.server.*" %>
<%@ page import="com.sas.oprisk.monitor.web.table.*" %>
<%@ page import="com.sas.oprisk.server.web.cpb.runtime.MonitorUIContext"%>
<%@ page import="com.sas.solutions.cpb.runtime.UIContext"%>
<%@ page import="com.sas.oprisk.monitor.web.cpb.util.UIContextUtil"%>
<%@ page import="com.sas.oprisk.monitor.web.csa.assessment.ratingsSummary.*"%>
<%@ page import="com.sas.oprisk.monitor.web.tags.QuestionTag"%>
<%@ include file="/tiles/taglibs.jsp" %>


<%
   final PersistenceSession psession = MonitorContext.getPersistenceSession(request);
   java.util.ResourceBundle bundle = ApplicationProperties.getBundle(request.getLocale());
   
   LinkedBusinessObjectsModel model = LinkedBusinessObjectsModel.getModelFromRequest(request);
   String createTitle;
   String linkTitle;
   String unlinkTitle;
   try
   {
       createTitle = java.text.MessageFormat.format(
          bundle.getString("linkedBusinessObjects.create.fmt.txt"),
          model.getTableTitle());
       linkTitle = java.text.MessageFormat.format(
         bundle.getString("linkedBusinessObjects.link.fmt.txt"),
         model.getTableTitle());
       unlinkTitle = java.text.MessageFormat.format(
         bundle.getString("linkedBusinessObjects.unlinkSelected.fmt.txt"),
         model.getTableTitle());
   }
   catch(Exception e)
   {
      createTitle= bundle.getString("linkedBusinessObjects.create.txt");
      linkTitle= bundle.getString("linkedBusinessObjects.link.txt");
      unlinkTitle=bundle.getString("linkedBusinessObjects.unlinkSelected.txt");
   }
       
   boolean required = false;
   ComponentFieldRenderer.ComponentInfo componentInfo =
      ComponentFieldRenderer.getComponentInfo(request);
   if (componentInfo != null && MonitorUIDefinitionType.COMP_LINKED_BUSINESS_OBJECTS.equals(
          componentInfo.getComponent().getName()))
   {
      required = componentInfo.isRequired();
   }
   String createLinkLocation=model.getCreateLinkLocation();
   boolean canBeCreated = createLinkLocation!=null;
   if(!canBeCreated)
   {
      String compName=model.getTargetBusinessObjectTypeInfo().getBusinessObjectTypeName();
      ModuleConfig moduleConfig=TagUtils.getInstance().getModuleConfig(pageContext);
      ForwardConfig[] fwds=moduleConfig.findActionConfig("/CreateAndLink").findForwardConfigs();   
      for(ForwardConfig fwd:fwds)
         if(canBeCreated=fwd.getName().equals(compName))
         {
            createLinkLocation=fwd.getPath();
            break;
         }
   }   
   boolean showCreateLink=model.isShowCreateLink();
   BusinessObjectList<ClassObject> targetBizObjList=new BusinessObjectList<ClassObject>();
   targetBizObjList.add(model.getTargetBusinessObjectTypeInfo().getClassObject());
   boolean hasCapabilityToCreate=SecurityUtils.canCreate(targetBizObjList,psession);
%>
<mon:tableComponent entryName="<%=model.getEntryId()%>"
                    id="entry"
                    required="<%= required %>"
                    wizCursor=""
                    exportXlsUrl="<%= model.getExportURL(request) %>">
   <mon:title><%=model.getTableTitle()%></mon:title>
   
<%
   // This hook of finding the Ratings model is used during assessment of a Risk Instance which has a linked potential impact(s).
   final LinkedBusinessObjectEntry entry = (LinkedBusinessObjectEntry)pageContext.findAttribute("entry");
   final boolean isRiskInstanceToPotentialImpactLink = 
      model.isRiskInstanceToPotentialImpactLink()
      && entry != null 
      && entry.getPrimaryBusinessObject() instanceof PotentialImpact;
   RatingsSummaryModel rsumModel = (RatingsSummaryModel)request.getAttribute(RatingsSummaryAction.ATTR_MODEL);
   if (rsumModel == null)
   {
      rsumModel = model.getRsumModel();
   }
   if (isRiskInstanceToPotentialImpactLink && rsumModel != null)
   {
      LayoutDirection layoutDirection = LayoutDirection.getLayoutDirection(request);
      
      final PotentialImpact impact = (PotentialImpact)entry.getPrimaryBusinessObject();
      
      final AssessmentAnswerSheet answerSheet = (AssessmentAnswerSheet)rsumModel.getAnswerSheet();
      final Assessment assessment = rsumModel.getAssessment();
      final java.sql.Timestamp ratingsTemplateFrozenDttm = assessment.getRatingsTemplateFrozenDttm(); 
      final ImpactAnswerContainer iac = impact == null ? null : answerSheet.getAnswersFor(impact, psession);
      
      for (ResponseScaleType measure : rsumModel.getFixedMeasuresForImpact())
      {
         final AssessmentAnswer answer = iac == null ? null : iac.getAnswerForResponseScaleType(measure.getHandle(), psession);
         String style = measure.getCurrencyFlg() ? "text-align:"+layoutDirection.getRight()+";vertical-align:top;white-space:nowrap;" : "text-align:"+layoutDirection.getLeft()+";vertical-align:top;white-space:nowrap;";
%>
            <mon:fixedColumn title='<%= measure.getName(psession) %>' before='false' style='<%=style%>'>
<%
            if (answer != null) {
               out.println(MeasureScoreCellFormatter.formatScore(
                  answer.getScore(), 
                  answer.getScoreCurrCd(), 
                  answer.getResponseScale(ratingsTemplateFrozenDttm, psession),
                  ratingsTemplateFrozenDttm, 
                  psession));
            }
%>
            </mon:fixedColumn>
<%
      }
   }

   if (!model.isReadOnly())
   {
      LinkInstance linkInstance = (entry == null) ? null : entry.getLinkInstance();
      
      String createNewHREF = 
         "javascript:LinkedBusinessObjects.createLinkInstance('"+ 
            model.getEntryId() + "', '"+ createLinkLocation +"')";

      String unlinkSelectedHREF =
         "javascript:LinkedBusinessObjects.unlinkBusinessObjects('" +
            StringUtil.escapeJSForHTMLAttribute(model.getEntryId()) + "', '" + StringUtil.escapeJSForHTMLAttribute(model.getTableTitle())+ "')";
      
      String linkHREF =
         "javascript:LinkedBusinessObjects.showLinkedBusinessObjectsChooser('" +
            model.getEntryId() + "')";
      if(canBeCreated && showCreateLink && hasCapabilityToCreate)
      {
%>
   <mon:action href="<%=createNewHREF%>">
      <%= createTitle %>
   </mon:action>
<%    } %>
   <mon:action href="<%=unlinkSelectedHREF%>">
      <%= unlinkTitle %>
   </mon:action>
   
   <mon:action href="<%=linkHREF%>" id="<%=model.getEntryId()%>">
      <%= linkTitle %>
   </mon:action>
   
   <mon:fixedColumn width="10" title="<%=model.getSelectAllCheckboxHTML()%>">
      <input type="checkbox" name="<%=model.getEntryId()%>.linkInstanceRkList" value="<%=linkInstance.getKey()%>"
         <%if (model.isPendingLink(linkInstance))
   {%>disabled="disabled"<%}%>/>
   </mon:fixedColumn>
   
   <mon:fixedColumn width='1%' title='<%=bundle.getString("displayTable.actions.txt")%>' before="false" >
               <%
                  if (!model.isPendingLink(linkInstance))
                  {
               %>
      <a href="javascript:LinkedBusinessObjects.editSingleBusinessObject({
            entryId: '<%=model.getEntryId()%>',
            linkInstanceRk: '<%=linkInstance.getLinkInstanceRk() %>'})" ><img
         border="0" src="<fmt:message key='application.edit.image' />"  
         alt="<fmt:message key='application.edit.tooltip.txt'/>" 
         title="<fmt:message key='application.edit.tooltip.txt'/>"/>
      </a>
      
      <a href="javascript:LinkedBusinessObjects.unlinkSingleBusinessObject('<%=model.getEntryId()%>', <%=linkInstance.getLinkInstanceRk() %>, '<%= entry.getUnlinkLabel() %>')" ><img
         border="0" src="<fmt:message key='application.remove.image' />"  
         alt="<fmt:message key='linkedBusinessObjects.unlink.txt'/>" 
         title="<fmt:message key='linkedBusinessObjects.unlink.txt'/>"/>
      </a>
      <%
   }
      %>
   </mon:fixedColumn>
<%
   }
%>
</mon:tableComponent>
<%
if (!model.isReadOnly())
{
%>
<script type="text/javascript">
CheckboxGroup.create("<%=model.getEntryId()%>.linkInstanceRkList", "<%=model.getSelectAllCheckboxName()%>");
</script>
<%
}



if (model.hasInvisibleItems())
{
%>
<mon:InfoMessage>
   <fmt:message key="linkedBusinessObjects.hasInvisibleItems.txt" />
</mon:InfoMessage>
<%
}
%>

<%
   if (model.hasPendingLinkToUnsavedObject())
{
%>
<mon:InfoMessage>
   <fmt:message key="linkedBusinessObjects.hasPendingItems.txt" />
</mon:InfoMessage>
<%
}
%>
